www-servers/tomcat: Version bumps, fix bug #453212, general cleanup
authorJames Le Cuirot <chewi@gentoo.org>
Sun, 16 Aug 2015 13:39:50 +0000 (14:39 +0100)
committerJames Le Cuirot <chewi@gentoo.org>
Sun, 16 Aug 2015 14:22:06 +0000 (15:22 +0100)
 * Version bumps for 7.0.63 and 8.0.24.
 * Start with a minimal classpath by prepending remaining jars to
   common.loader instead. Fixes bug #453212.
 * Unbundle javamail at runtime and servlet-api at build time.
 * Clean up test handling and add missing easymock dependency.
 * Fix handling of websockets flag under 7.

Package-Manager: portage-2.2.20.1

www-servers/tomcat/Manifest
www-servers/tomcat/files/tomcat-6.0.44-build.xml.patch
www-servers/tomcat/files/tomcat-7.0.63-build.xml.patch [new file with mode: 0644]
www-servers/tomcat/files/tomcat-8.0.24-build.xml.patch [new file with mode: 0644]
www-servers/tomcat/files/tomcat-instance-manager.bash [deleted file]
www-servers/tomcat/files/tomcat-r1.init [new file with mode: 0644]
www-servers/tomcat/files/tomcat.conf
www-servers/tomcat/tomcat-6.0.44-r1.ebuild [new file with mode: 0644]
www-servers/tomcat/tomcat-7.0.63.ebuild [new file with mode: 0644]
www-servers/tomcat/tomcat-8.0.24.ebuild [new file with mode: 0644]

index dafdb4ce8c6cb96809da53a66dd0e732297d7591..1b82f42785899db1ea31a3e7dc3d648e4e75aca2 100644 (file)
@@ -1,3 +1,5 @@
 DIST apache-tomcat-6.0.44-src.tar.gz 3447711 SHA256 c6f01526d58f2ba7b9da496e959d9e68cc49183006077704ab91c36ebebf5a4a SHA512 0d6a1539b28fa8ca3442557889d7d21cc523b18136f6998820ba13f41420536aba65ce78bac526002ee1dd86df3cbc80d9f043a3f765d7cf0b79e58e516030be WHIRLPOOL c65e704466191a0f98ec777e95dda889599ff6a545e7c013fd04bc0b72e0d0edf4491415f243d6a4de60cf76abe5c13ffbcc6d98f78b51490f7b7b43b24ecb97
 DIST apache-tomcat-7.0.59-src.tar.gz 4687344 SHA256 3a1dedda4019db87464fca3aeb4e800a538f0baee96d8b14c9d64967b0d2ea44 SHA512 acc322eee1446dd1bff72910ae9f40a62f88332ee69d6057b3c684e2abf8f28e6df6ab9505900f0b0cf7a5e2e0e80e64b0a790b3b78594ce595ce897706b4bcb WHIRLPOOL 4948964c1746e6ee912ac72c901ba271793610f402bf082455d104e2e8d6dbfa0bf5371d42d48d8ad7c826271fa60d989119a01e700497099022d0cf3564fdff
+DIST apache-tomcat-7.0.63-src.tar.gz 4577737 SHA256 443aa92f2668906fb24cc43ba952068240f445df637a6e5da8d4661527536657 SHA512 677b28aa0131d309aed83afc73a778c16fd27a187e971ea6929b9b6b65268caa2a67cc468b15565a7d5944a60e8528cc26c82437b476ebc41ff9556367349d8a WHIRLPOOL a208ac63ed6f7ce7ac23674d8bb20d523b3fb5d10dfb46d292004f9b296986c4cab690f0252ad53bb4c625c3f58e04b9ddcda5a580fdafea20118b93f544760c
 DIST apache-tomcat-8.0.23-src.tar.gz 4868650 SHA256 6293713e78da9bb803060c8ddff982f8f7aef5a2e4b325340088493ce9957ba4 SHA512 cc83194b2847fc2db5448d548c7e65a1198cda02726b070f913a762d324152315886fba09532b879e26d15ec57e04057cc30b3a686b2a2307d6447d17f84e16c WHIRLPOOL b0559a4ef1b4c1f0683e4cce976d31db175d3c4f4d2b809b127e1074d49a6bf764366cc3e91f9a0818afd6de35e662a7aab89866dfd2e61673327c50535bff88
+DIST apache-tomcat-8.0.24-src.tar.gz 4888751 SHA256 184b0d8bda512204a2e565f9175a13f9772a9d13185e1aa228394b45c641474c SHA512 af5619a63db3d1f6d39eb0290c83a38272c31803ee39a40aebfba5f7a0cf67d830ffcbebe518aff8de4a1f8eb44021975d7e43d45b4bd9804e8ca9cfbfc4904a WHIRLPOOL 4d37f4d1fe3ee138252813bd4a65025d0ccceea8aec57aa0c9474ad4902f85938627277f6e4ece30793326c31d7790b0ca0b8d99d7b21857519d7c22c28794e8
index 6517dee4d1967500b012e047f720b8d38d14cc78..eaa1963e76bf1e3af898547c76169d278c45b122 100644 (file)
@@ -1,6 +1,41 @@
---- build.xml.orig     2012-07-06 20:26:21.361299240 +0200
-+++ build.xml  2012-07-06 20:26:56.085899911 +0200
-@@ -487,12 +487,14 @@
+diff -Naur apache-tomcat-6.0.44-src.orig/build.xml apache-tomcat-6.0.44-src/build.xml
+--- apache-tomcat-6.0.44-src.orig/build.xml    2015-05-08 13:22:05.000000000 +0100
++++ apache-tomcat-6.0.44-src/build.xml 2015-08-16 14:10:03.609366396 +0100
+@@ -159,12 +159,14 @@
+       </fileset>
+     </copy>
+     <!-- Copy JSP Schemas and DTDs to be packed into servlet-api.jar -->
++<!--
+     <copy todir="${tomcat.classes}/javax/servlet/resources" encoding="ISO-8859-1">
+       <fileset dir="${tomcat.classes}/javax/servlet/jsp/resources">
+         <include name="*" />
+         <exclude name="jspxml*" />
+       </fileset>
+     </copy>
++ -->
+   </target>
+@@ -307,14 +309,18 @@
+       manifest="${tomcat.manifests}/annotations-api.jar.manifest" />
+     <!-- Servlet 2.5 Implementation JAR File -->
++<!--
+     <jarIt jarfile="${servlet-api.jar}" filesId="files.servlet-api"
+       manifest="${tomcat.manifests}/servlet-api.jar.manifest"
+       license="${tomcat.manifests}/servlet-api.jar.license"
+       notice="${tomcat.manifests}/servlet-api.jar.notice" />
++-->
+     <!-- JSP 2.1 Implementation JAR File -->
++<!--
+     <jarIt jarfile="${jsp-api.jar}" filesId="files.jsp-api"
+       manifest="${tomcat.manifests}/jsp-api.jar.manifest" />
++-->
+     <!-- JSP 2.1 EL Implementation JAR File -->
+@@ -492,12 +498,14 @@
  
    <target name="deploy" depends="build-only,build-docs,warn.dbcp">
  
@@ -15,9 +50,7 @@
  
      <!-- Copy scripts -->
      <copy todir="${tomcat.build}/bin">
---- build.xml.orig     2012-07-06 20:31:31.387806167 +0200
-+++ build.xml  2012-07-06 20:32:33.185315885 +0200
-@@ -646,9 +646,11 @@
+@@ -649,9 +657,11 @@
        </fileset>
      </txt2html>
  
diff --git a/www-servers/tomcat/files/tomcat-7.0.63-build.xml.patch b/www-servers/tomcat/files/tomcat-7.0.63-build.xml.patch
new file mode 100644 (file)
index 0000000..23181e7
--- /dev/null
@@ -0,0 +1,121 @@
+diff -Naur apache-tomcat-7.0.63-src.orig/build.xml apache-tomcat-7.0.63-src/build.xml
+--- apache-tomcat-7.0.63-src.orig/build.xml    2015-06-30 09:15:44.000000000 +0100
++++ apache-tomcat-7.0.63-src/build.xml 2015-08-16 14:17:34.594426081 +0100
+@@ -660,12 +660,14 @@
+       </fileset>
+     </copy>
+     <!-- Copy JSP Schemas and DTDs to be packed into servlet-api.jar -->
++<!--
+     <copy todir="${tomcat.classes}/javax/servlet/resources" encoding="ISO-8859-1">
+       <fileset dir="${tomcat.classes}/javax/servlet/jsp/resources">
+         <include name="*" />
+         <exclude name="jspxml*" />
+       </fileset>
+     </copy>
++-->
+   </target>
+@@ -721,26 +723,32 @@
+       manifest="${tomcat.manifests}/annotations-api.jar.manifest" />
+     <!-- Servlet 3.0 Implementation JAR File -->
++<!--
+     <jarIt jarfile="${servlet-api.jar}"
+       filesDir="${tomcat.classes}"
+       filesId="files.servlet-api"
+       manifest="${tomcat.manifests}/servlet-api.jar.manifest"
+       notice="${tomcat.manifests}/servlet-api.jar.notice"
+       license="${tomcat.manifests}/servlet-api.jar.license" />
++-->
+     <!-- JSP 2.2 Implementation JAR File -->
++<!--
+     <jarIt jarfile="${jsp-api.jar}"
+       filesDir="${tomcat.classes}"
+       filesId="files.jsp-api"
+       manifest="${tomcat.manifests}/jsp-api.jar.manifest"
+       notice="${tomcat.manifests}/jsp-api.jar.notice"
+       license="${tomcat.manifests}/jsp-api.jar.license" />
++-->
+     <!-- JSP 2.2 EL Implementation JAR File -->
++<!--
+     <jarIt jarfile="${el-api.jar}"
+       filesDir="${tomcat.classes}"
+       filesId="files.el-api"
+       manifest="${tomcat.manifests}/el-api.jar.manifest" />
++-->
+     <!-- Bootstrap JAR File -->
+     <jarIt jarfile="${bootstrap.jar}"
+@@ -986,12 +994,14 @@
+   <target name="deploy" depends="package,build-docs,compile-webapp-examples"
+           description="Default. Builds a working Tomcat instance">
++<!--
+     <copy tofile="${tomcat.build}/bin/tomcat-native.tar.gz"
+             file="${tomcat-native.tar.gz}" />
+     <copy tofile="${tomcat.build}/bin/commons-daemon-native.tar.gz"
+             file="${commons-daemon.native.src.tgz}" />
+     <copy tofile="${tomcat.build}/bin/commons-daemon.jar" file="${commons-daemon.jar}" />
++-->
+     <!-- Copy scripts -->
+     <copy todir="${tomcat.build}/bin">
+@@ -1051,14 +1061,15 @@
+         <exclude name="${jdt.jar.filename}"/>
+       </fileset>
+     </delete>
++<!--
+     <copy file="${jdt.jar}" todir="${tomcat.build}/lib"/>
+-
++-->
+     <!-- Add sources for examples -->
+     <antcall target="examples-sources" />
+-
++<!--
+     <copy file="${tomcat-dbcp.jar}" todir="${tomcat.build}/lib"
+       failonerror="false"/>
+-
++-->
+     <!-- build the jdbc-pool jar and source jar-->
+     <echo message="Building Tomcat JDBC pool libraries"/>
+     <ant antfile="${tomcat.jdbc.dir}/build.xml" dir="${tomcat.jdbc.dir}"
+@@ -1681,7 +1692,7 @@
+   <target name="extras-webservices-prepare"
+           depends="extras-prepare"
+-          description="Prepare to build web services extras package">
++          description="Prepare to build web services extras package" unless="noget">
+     <antcall target="downloadfile">
+       <param name="sourcefile" value="${jaxrpc-lib.loc}"/>
+@@ -2642,7 +2653,7 @@
+   </target>
+   <target name="download-compile"
+-          description="Download (and build) components necessary to compile" >
++          description="Download (and build) components necessary to compile" unless="noget">
+     <antcall target="downloadfile-2">
+       <param name="sourcefile.1" value="${tomcat-native.loc.1}"/>
+@@ -2699,7 +2710,7 @@
+   </target>
+   <target name="download-test-compile"
+-          description="Download additional components for the tests" >
++          description="Download additional components for the tests" unless="noget">
+     <antcall target="downloadfile">
+       <param name="sourcefile" value="${junit.loc}"/>
+@@ -2727,7 +2738,7 @@
+   </target>
+   <target name="download-dist"
+-          description="Download additional components for a distribution" >
++          description="Download additional components for a distribution" unless="noget">
+     <antcall target="downloadzip-2">
+       <param name="sourcefile.1" value="${tomcat-native.win.1}"/>
diff --git a/www-servers/tomcat/files/tomcat-8.0.24-build.xml.patch b/www-servers/tomcat/files/tomcat-8.0.24-build.xml.patch
new file mode 100644 (file)
index 0000000..9854c9d
--- /dev/null
@@ -0,0 +1,230 @@
+diff -Naur apache-tomcat-8.0.24-src.orig/build.xml apache-tomcat-8.0.24-src/build.xml
+--- apache-tomcat-8.0.24-src.orig/build.xml    2015-07-01 21:25:21.000000000 +0100
++++ apache-tomcat-8.0.24-src/build.xml 2015-08-14 13:45:50.315788075 +0100
+@@ -697,24 +697,29 @@
+       manifest="${tomcat.manifests}/annotations-api.jar.manifest" />
+     <!-- Servlet 3.1 Implementation JAR File -->
++<!--
+     <jarIt jarfile="${servlet-api.jar}"
+       filesDir="${tomcat.classes}"
+       filesId="files.servlet-api"
+       manifest="${tomcat.manifests}/servlet-api.jar.manifest"
+       notice="${tomcat.manifests}/servlet-api.jar.notice"
+       license="${tomcat.manifests}/servlet-api.jar.license" />
+-
++-->
+     <!-- JSP 2.3 Implementation JAR File -->
++<!--
+     <jarIt jarfile="${jsp-api.jar}"
+       filesDir="${tomcat.classes}"
+       filesId="files.jsp-api"
+       manifest="${tomcat.manifests}/jsp-api.jar.manifest" />
++-->
+     <!-- EL 3.0 Implementation JAR File -->
++<!--
+     <jarIt jarfile="${el-api.jar}"
+       filesDir="${tomcat.classes}"
+       filesId="files.el-api"
+       manifest="${tomcat.manifests}/el-api.jar.manifest" />
++-->
+     <!-- WebSocket 1.1 API JAR File -->
+     <jarIt jarfile="${websocket-api.jar}"
+@@ -982,14 +987,14 @@
+   <target name="deploy" depends="package,build-docs,build-tomcat-jdbc,compile-webapp-examples"
+           description="Default. Builds a working Tomcat instance">
+-
++<!--
+     <copy tofile="${tomcat.build}/bin/tomcat-native.tar.gz"
+             file="${tomcat-native.tar.gz}" />
+     <copy tofile="${tomcat.build}/bin/commons-daemon-native.tar.gz"
+             file="${commons-daemon.native.src.tgz}" />
+     <copy tofile="${tomcat.build}/bin/commons-daemon.jar" file="${commons-daemon.jar}" />
+-
++-->
+     <!-- Copy scripts -->
+     <copy todir="${tomcat.build}/bin">
+       <fileset dir="bin">
+@@ -1049,7 +1054,7 @@
+         <exclude name="${jdt.jar.filename}"/>
+       </fileset>
+     </delete>
+-    <copy file="${jdt.jar}" todir="${tomcat.build}/lib"/>
++<!--    <copy file="${jdt.jar}" todir="${tomcat.build}/lib"/> -->
+     <!-- Add sources for examples -->
+     <antcall target="examples-sources" />
+@@ -1083,7 +1088,7 @@
+     </javac>
+   </target>
+-  <target name="build-tomcat-jdbc" depends="package">
++  <target name="build-tomcat-jdbc" depends="package" unless="noget">
+     <!-- build the jdbc-pool jar and source jar-->
+     <echo message="Building Tomcat JDBC pool libraries"/>
+     <ant antfile="${tomcat.jdbc.dir}/build.xml" dir="${tomcat.jdbc.dir}"
+@@ -1098,7 +1103,7 @@
+     <copy file="${tomcat-jdbc.jar}" todir="${tomcat.build}/lib"/>
+   </target>
+-  <target name="build-tomcat-jdbc-src">
++  <target name="build-tomcat-jdbc-src" unless="noget">
+     <!-- build the jdbc-pool source jar-->
+     <echo message="Building Tomcat JDBC pool src JAR"/>
+     <ant antfile="${tomcat.jdbc.dir}/build.xml" dir="${tomcat.jdbc.dir}"
+@@ -1202,10 +1207,11 @@
+     <copy file="${basedir}/LICENSE" todir="${tomcat.embed}" />
+     <copy file="${basedir}/NOTICE" todir="${tomcat.embed}" />
++<!--
+     <copy file="${tomcat-dbcp.jar}" todir="${tomcat.embed}"
+       failonerror="false"/>
+     <copy file="${jdt.jar}" todir="${tomcat.embed}" />
+-
++-->
+     <!-- Note the meta-inf below will work as long as there is only one JAR
+          that needs to add entries. If there is more than one a more complex
+          solution will be required. -->
+@@ -1542,7 +1548,7 @@
+   <target name="extras-commons-logging-prepare"
+           depends="extras-prepare"
+-          description="Prepare to build web services extras package">
++          description="Prepare to build web services extras package" unless="noget">
+     <antcall target="downloadfile-2">
+       <param name="sourcefile.1" value="${commons-logging-src.loc.1}"/>
+@@ -1681,7 +1687,7 @@
+   <target name="extras-webservices-prepare"
+           depends="extras-prepare"
+-          description="Prepare to build web services extras package">
++          description="Prepare to build web services extras package" unless="noget">
+     <antcall target="downloadfile">
+       <param name="sourcefile" value="${jaxrpc-lib.loc}"/>
+@@ -2739,7 +2745,7 @@
+   </target>
+   <target name="download-compile"
+-          description="Download (and build) components necessary to compile" >
++          description="Download (and build) components necessary to compile" unless="noget">
+     <antcall target="downloadfile-2">
+       <param name="sourcefile.1" value="${tomcat-native.loc.1}"/>
+@@ -2773,7 +2779,7 @@
+   </target>
+   <target name="download-test-compile"
+-          description="Download additional components for the tests" >
++          description="Download additional components for the tests" unless="noget">
+     <antcall target="downloadfile">
+       <param name="sourcefile" value="${junit.loc}"/>
+@@ -2819,7 +2825,7 @@
+   </target>
+   <target name="download-dist"
+-          description="Download additional components for a distribution" >
++          description="Download additional components for a distribution" unless="noget">
+     <antcall target="downloadzip-2">
+       <param name="sourcefile.1" value="${tomcat-native.win.1}"/>
+@@ -2845,18 +2851,18 @@
+   <!-- =============== Utility Targets to support downloads ================ -->
+-  <target name="setproxy" if="${proxy.use}">
++  <target name="setproxy" if="${proxy.use}" unless="noget">
+     <setproxy proxyhost="${proxy.host}" proxyport="${proxy.port}"
+               proxyuser="${proxy.user}" proxypassword="${proxy.password}" />
+     <echo message="Using ${proxy.host}:${proxy.port} to download ${sourcefile}"/>
+   </target>
+-  <target name="testexist">
++  <target name="testexist" unless="noget">
+     <echo message="Testing  for ${destfile}"/>
+     <available file="${destfile}" property="exist"/>
+   </target>
+-  <target name="downloadgz" unless="exist" depends="testexist,setproxy">
++  <target name="downloadgz" unless="noget" depends="testexist,setproxy">
+     <!-- Download and extract the package -->
+     <local name="temp.file"/>
+     <mkdir dir="${base.path}"/>
+@@ -2868,7 +2874,7 @@
+     <delete file="${temp.file}.tar.gz"/>
+   </target>
+-  <target name="downloadgz-2" unless="exist" depends="testexist">
++  <target name="downloadgz-2" unless="noget" depends="testexist">
+     <!-- Download and extract the package from the two alternative locations -->
+     <local name="temp.file"/>
+     <mkdir dir="${base.path}"/>
+@@ -2887,7 +2893,7 @@
+     <delete file="${temp.file}.tar.gz"/>
+   </target>
+-  <target name="downloadzip" unless="exist" depends="testexist,setproxy">
++  <target name="downloadzip" unless="noget" depends="testexist,setproxy">
+     <!-- Download and extract the package -->
+     <local name="temp.file"/>
+     <mkdir dir="${base.path}"/>
+@@ -2898,7 +2904,7 @@
+     <delete file="${temp.file}"/>
+   </target>
+-  <target name="downloadzip-2" unless="exist" depends="testexist">
++  <target name="downloadzip-2" unless="noget" depends="testexist">
+     <!-- Download and extract the package from the two alternative locations -->
+     <local name="temp.file"/>
+     <mkdir dir="${base.path}"/>
+@@ -2916,7 +2922,7 @@
+     <delete file="${temp.file}"/>
+   </target>
+-  <target name="downloadfile" unless="exist" depends="testexist,setproxy">
++  <target name="downloadfile" unless="noget" depends="testexist,setproxy">
+     <!-- Download the file -->
+     <local name="temp.file"/>
+     <mkdir dir="${base.path}"/>
+@@ -2926,7 +2932,7 @@
+     <move file="${temp.file}" tofile="${destfile}"/>
+   </target>
+-  <target name="downloadfile-2" unless="exist" depends="testexist">
++  <target name="downloadfile-2" unless="noget" depends="testexist">
+     <!-- Download the file from the two alternative locations -->
+     <local name="temp.file"/>
+     <mkdir dir="${base.path}"/>
+@@ -2949,7 +2955,7 @@
+     <move file="${temp.file}" tofile="${destfile}"/>
+   </target>
+-  <target name="trydownload.check" depends="setproxy">
++  <target name="trydownload.check" depends="setproxy" unless="noget">
+     <condition property="trydownload.run">
+       <and>
+         <not>
+@@ -2960,7 +2966,7 @@
+     </condition>
+   </target>
+-  <target name="trydownload" if="trydownload.run" depends="trydownload.check">
++  <target name="trydownload" if="trydownload.run" depends="trydownload.check" unless="noget">
+     <!-- Downloads a file if not yet downloaded and the source URL is available -->
+     <get src="${sourcefile}" httpusecaches="${trydownload.httpusecaches}" dest="${destfile}" />
+   </target>
+@@ -2971,7 +2977,7 @@
+   <target name="ide-eclipse"
+           depends="download-compile, extras-webservices-prepare, download-test-compile"
+-          description="Prepares the source tree to be built in Eclipse">
++          description="Prepares the source tree to be built in Eclipse" unless="noget">
+     <!-- Copy the sample project files into the root directory -->
+     <copy file="${tomcat.home}/res/ide-support/eclipse/eclipse.project" tofile="${tomcat.home}/.project"/>
diff --git a/www-servers/tomcat/files/tomcat-instance-manager.bash b/www-servers/tomcat/files/tomcat-instance-manager.bash
deleted file mode 100644 (file)
index fcdfebf..0000000
+++ /dev/null
@@ -1,240 +0,0 @@
-#!/bin/bash
-# Copyright 1999-2012 Gentoo Foundation
-# Distributed under the terms of the GNU General Public License v2
-# Author: Ralph Sennhauser <sera@gentoo.org>
-
-die() {
-       echo "${@}"
-       exit 1
-}
-
-usage() {
-       cat <<EOL
-Usage: ${BASH_SOURCE} <--create|--remove|--help> [--suffix s][--user u][--group g]
-
-  Options:
-    --help:
-      show this text.
-    --create:
-      create a new instance
-    --remove:
-      remove an existing instance.
-    --suffix SUFFIX:
-      a suffix for this instance. the suffix may not collide with an already
-      existing instance, defaults to empty.
-    --user USER:
-      the user for which to configure this instance for. The user needs to
-      exist already. defaults to tomcat.
-    --group GROUP:
-      the group for which to configure this instance for. The group needs to
-      exist already. defaults to tomcat.
-
-  Examples:
-    ${BASH_SOURCE} --create --suffix testing --user tacmot --group tacmot
-    ${BASH_SOURCE} --remove --suffix testing
-EOL
-}
-
-parse_argv() {
-       action="not specified"
-       instance_name="tomcat-@SLOT@"
-       instance_user="tomcat"
-       instance_group="tomcat"
-
-       while [[ -n $1 ]]; do
-               case $1 in
-                       --help)
-                               usage
-                               exit 0;;
-                       --suffix)
-                               instance_name+="-$2"
-                               shift; shift;;
-                       --user)
-                               instance_user="$2"
-                               shift; shift;;
-                       --group)
-                               instance_group="$2"
-                               shift; shift;;
-                       --create)
-                               action=create
-                               shift;;
-                       --remove)
-                               action=remove
-                               shift;;
-                       --backup)
-                               action=backup
-                               shift;;
-                       --restore)
-                               action=restore
-                               shift;;
-                       --update)
-                               action=update
-                               shift;;
-                       *)
-                               echo "Invalid option '$1'"
-                               usage
-                               exit 2;;
-               esac
-       done
-
-       tomcat_home="/@GENTOO_PORTAGE_EPREFIX@usr/share/tomcat-@SLOT@"
-       instance_base="/@GENTOO_PORTAGE_EPREFIX@var/lib/${instance_name}"
-       instance_conf="/@GENTOO_PORTAGE_EPREFIX@etc/${instance_name}"
-       instance_logs="/@GENTOO_PORTAGE_EPREFIX@var/log/${instance_name}"
-       instance_temp="/@GENTOO_PORTAGE_EPREFIX@var/tmp/${instance_name}"
-
-       all_targets=(
-               "${instance_base}"
-               "${instance_logs}"
-               "${instance_temp}"
-               "/@GENTOO_PORTAGE_EPREFIX@etc/${instance_name}"
-               "/@GENTOO_PORTAGE_EPREFIX@etc/init.d/${instance_name}"
-               "/@GENTOO_PORTAGE_EPREFIX@etc/conf.d/${instance_name}"
-       )
-}
-       
-test_can_deploy() {
-       local no_deploy target
-       for target in "${all_targets[@]}"; do
-               if [[ -e "${target}" ]]; then 
-                       echo "Error: '${target}' already exists."
-                       no_deploy=yes
-               fi
-       done
-       if [[ -n "${no_deploy}" ]]; then
-               cat <<-EOL
-
-                       To protect an existing installation no new instance was deployed. You can use
-                       '${BASH_SOURCE} --remove'
-                       to remove an existing instance first or run
-                       '${BASH_SOURCE} --create --sufix <instance_suffix>'
-                       to deploy an instance under a different name
-
-               EOL
-               usage
-               exit 1
-       fi
-
-       if ! id --user "${instance_user}" >/dev/null 2>&1; then
-               echo "Error: user '${instance_user}' doesn't exist."
-               exit 1
-       fi
-
-       if ! id --group "${instance_group}" >/dev/null 2>&1; then
-               echo "Error: group '${instance_group}' doesn't exist."
-               exit 1
-       fi
-}
-
-deploy_instance() {
-       test_can_deploy
-
-       mkdir -p "${instance_base}"/{work,webapps} || die
-       mkdir -p "${instance_logs}" || die
-       mkdir -p "${instance_temp}" || die
-
-       cp -r "${tomcat_home}"/webapps/ROOT "${instance_base}"/webapps || die
-
-       chown -R "${instance_user}":"${instance_group}" \
-               "${instance_base}" "${instance_logs}" "${instance_temp}" || die
-
-       find "${instance_base}"/webapps -type d -exec chmod 750 {} + || die
-       find "${instance_base}"/webapps -type f -exec chmod 640 {} + || die
-
-       # initial config #
-
-       cp -r "${tomcat_home}"/conf "${instance_conf}" || die
-
-       sed -i -e "s|\${catalina.base}/logs|${instance_logs}|" \
-               "${instance_conf}"/logging.properties || die
-       sed -i -e "s|directory=\"logs\"|directory=\"${instance_logs}\"|" \
-               "${instance_conf}"/server.xml || die
-
-       mkdir -p "${instance_conf}"/Catalina/localhost || die
-       cat > "${instance_conf}"/Catalina/localhost/host-manager.xml <<-'EOF'
-               <?xml version="1.0" encoding="UTF-8"?>
-               <Context docBase="${catalina.home}/webapps/host-manager"
-                               antiResourceLocking="false" privileged="true" />
-       EOF
-
-       cat > "${instance_conf}"/Catalina/localhost/manager.xml <<-'EOF'
-               <?xml version="1.0" encoding="UTF-8"?>
-               <Context docBase="${catalina.home}/webapps/manager"
-                               antiResourceLocking="false" privileged="true" />
-       EOF
-
-       if [[ -d "${tomcat_home}"/webapps/docs ]]; then
-               cat > "${instance_conf}"/Catalina/localhost/docs.xml <<-'EOF'
-                       <?xml version="1.0" encoding="UTF-8"?>
-                       <Context docBase="${catalina.home}/webapps/docs" />
-               EOF
-       fi
-
-       if [[ -d "${tomcat_home}"/webapps/examples ]]; then
-               cat > "${instance_conf}"/Catalina/localhost/examples.xml <<-'EOF'
-                       <?xml version="1.0" encoding="UTF-8"?>
-                       <Context docBase="${catalina.home}/webapps/examples" />
-               EOF
-       fi
-
-       chown -R "${instance_user}":"${instance_group}" "${instance_conf}" || die
-       find "${instance_conf}" -type d -exec chmod 750 {} + || die
-       find "${instance_conf}" -type f -exec chmod 640 {} + || die
-
-       # rc script #
-
-       cp "${tomcat_home}"/gentoo/tomcat.init \
-               "/@GENTOO_PORTAGE_EPREFIX@etc/init.d/${instance_name}" || die
-
-       sed -e "s|@INSTANCE_NAME@|${instance_name}|g" \
-               -e "s|@INSTANCE_USER@|${instance_user}|g" \
-               -e "s|@INSTANCE_GROUP@|${instance_group}|g" \
-               "${tomcat_home}"/gentoo/tomcat.conf \
-               > "/@GENTOO_PORTAGE_EPREFIX@etc/conf.d/${instance_name}" || die
-
-       # some symlinks for tomcat and netbeans #
-
-       ln -s "${instance_conf}" "${instance_base}"/conf || die
-       ln -s "${instance_temp}" "${instance_base}"/temp || die
-
-       # a note to update the default configuration #
-
-       cat <<-EOL
-               Successfully created instance '${instance_name}'
-               It's strongly recommended for production systems to go carefully through the
-               configuration files at '${instance_conf}'.
-               The generated initial configuration is close to upstreams default which
-               favours the demo aspect over hardening.
-       EOL
-}
-
-remove_instance() {
-       echo "The following files will be removed permanently:"
-       local target; for target in "${all_targets[@]}"; do
-               find ${target}
-       done
-
-       echo "Type 'yes' to continue"
-       read
-       if [[ ${REPLY} == yes ]]; then
-               rm -rv "${all_targets[@]}"
-       else 
-               echo "Aborting as requested ..."
-       fi
-}
-
-parse_argv "$@"
-
-if [[ ${action} == create ]]; then
-       deploy_instance
-elif [[ ${action} == remove ]]; then
-       remove_instance
-elif [[ ${action} == "not specified" ]]; then
-       echo "No action specified!"
-       usage
-       exit 1
-else
-       echo "${action} not yet implemented!"
-       usage
-       exit 1
-fi
diff --git a/www-servers/tomcat/files/tomcat-r1.init b/www-servers/tomcat/files/tomcat-r1.init
new file mode 100644 (file)
index 0000000..3a69a9d
--- /dev/null
@@ -0,0 +1,111 @@
+#!/@GENTOO_PORTAGE_EPREFIX@sbin/runscript
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+extra_commands="forcestop"
+
+PIDFILE=/@GENTOO_PORTAGE_EPREFIX@var/run/${RC_SVCNAME}.pid
+
+: ${CATALINA_HOME:=/@GENTOO_PORTAGE_EPREFIX@usr/share/tomcat-@SLOT@}
+: ${CATALINA_BASE:=/@GENTOO_PORTAGE_EPREFIX@var/lib/${RC_SVCNAME}}
+: ${CATALINA_TMPDIR:=/@GENTOO_PORTAGE_EPREFIX@var/tmp/${RC_SVCNAME}}
+: ${CATALINA_USER:=tomcat}
+: ${CATALINA_GROUP:=tomcat}
+
+: ${TOMCAT_START:=start}
+
+: ${JPDA_TRANSPORT:="dt_socket"}
+: ${JPDA_ADDRESS:="8000"}
+: ${JPDA_OPTS="-Xdebug -Xrunjdwp:transport=${JPDA_TRANSPORT},address=${JPDA_ADDRESS},server=y,suspend=n"}
+
+export JAVA_HOME=`java-config ${TOMCAT_JVM:+--select-vm ${TOMCAT_JVM}} --jre-home`
+export CLASSPATH="${CATALINA_HOME}/bin/bootstrap.jar:${CATALINA_HOME}/bin/tomcat-juli.jar"
+[[ @SLOT@ = 6 ]] && CLASSPATH+=":/@GENTOO_PORTAGE_EPREFIX@usr/share/tomcat-servlet-api-2.5/lib/jsp-api.jar:/@GENTOO_PORTAGE_EPREFIX@usr/share/tomcat-servlet-api-2.5/lib/servlet-api.jar"
+
+depend() {
+       use dns logger net
+}
+
+start()        {
+       ebegin "Starting ${RC_SVCNAME}"
+
+       if [ ! -e "${CATALINA_TMPDIR}" ]; then
+               eerror "CATALINA_TMPDIR does not exist. Unable to start tomcat."
+               eerror "Please see /@GENTOO_PORTAGE_EPREFIX@etc/conf.d/${RC_SVCNAME} for more information."
+               eend 1
+       fi
+
+       local DEPEND=$(java-config --query DEPEND --package tomcat-@SLOT@):${TOMCAT_EXTRA_JARS}
+       DEPEND=${DEPEND%:}
+
+       local GCLASSPATH=$(java-config --with-dependencies --classpath "${DEPEND//:/,}"):${TOMCAT_EXTRA_CLASSPATH}
+       GCLASSPATH=${GCLASSPATH%:}
+
+       local cmd=java args=
+       if [ "${TOMCAT_START}" = "debug" ] || [ "${TOMCAT_START}" = "-security debug" ] ; then
+               cmd=jdb
+               args="${args} -sourcepath ${CATALINA_HOME}/../../jakarta-tomcat-catalina/catalina/src/share"
+       fi
+       if [ "${TOMCAT_START}" = "-security debug" ] || [ "${TOMCAT_START}" = "-security start" ]; then
+               args="${args} -Djava.security.manager"
+               args="${args} -Djava.security.policy=${CATALINA_BASE}/conf/catalina.policy"
+       fi
+       if [ "${TOMCAT_START}" = "jpda start" ] ; then
+               args="${args} ${JPDA_OPTS}"
+       fi
+       if [ -r "${CATALINA_HOME}"/bin/tomcat-juli.jar ]; then
+               args="${args} -Djava.util.logging.manager=org.apache.juli.ClassLoaderLogManager \
+               -Djava.util.logging.config.file=${CATALINA_BASE}/conf/logging.properties"
+       fi
+
+       start-stop-daemon  --start \
+               --quiet --background \
+               --chdir "${CATALINA_TMPDIR}" \
+               --user ${CATALINA_USER}:${CATALINA_GROUP} \
+               --make-pidfile --pidfile ${PIDFILE} \
+               --exec ${JAVA_HOME}/bin/${cmd} \
+               -- \
+                       ${JAVA_OPTS} \
+                       ${args} \
+                       -Dcatalina.base="${CATALINA_BASE}" \
+                       -Dcatalina.home="${CATALINA_HOME}" \
+                       -Djava.io.tmpdir="${CATALINA_TMPDIR}" \
+                       -Dgentoo.classpath="${GCLASSPATH//:/,}" \
+                       -classpath "${CLASSPATH}" \
+                       org.apache.catalina.startup.Bootstrap \
+                       ${CATALINA_OPTS} \
+                       ${TOMCAT_START}
+
+       eend $?
+}
+
+stop() {
+       ebegin "Stopping '${RC_SVCNAME}'"
+
+       start-stop-daemon --stop \
+               --quiet --retry=60 \
+               --pidfile ${PIDFILE} \
+               --exec ${JAVA_HOME}/bin/java \
+               -- \
+                       ${JAVA_OPTS} \
+                       -classpath "${CLASSPATH}" \
+                       ${CATALINA_OPTS} \
+                       stop ${STD_OUT}
+
+       eend $?
+}
+
+forcestop()    {
+       ebegin "Forcing '${RC_SVCNAME}' to stop"
+
+       start-stop-daemon --stop \
+               --quiet --retry=60 \
+               --pidfile ${PIDFILE} \
+               --signal=9
+
+       if service_started "${RC_SVCNAME}"; then
+               mark_service_stopped "${RC_SVCNAME}"
+       fi
+
+       eend $?
+}
index a27f93342678d95532678081191b19133ac6ad68..376af44adef66255ab79877a587844bf61406b84 100644 (file)
 #
 #TOMCAT_EXTRA_JARS=""
 
+# Additional paths to put on the default classpath.
+# These should be separated by the : character.
+# Note: The extra jars listed here will be visible to webapps.
+# Example:
+#   TOMCAT_EXTRA_CLASSPATH="/path/to/foo.jar:/path/to/bar.jar"
+#
+#TOMCAT_EXTRA_CLASSPATH=""
+
 # User/Group of this instance.
 CATALINA_USER=@INSTANCE_USER@
 CATALINA_GROUP=@INSTANCE_GROUP@
diff --git a/www-servers/tomcat/tomcat-6.0.44-r1.ebuild b/www-servers/tomcat/tomcat-6.0.44-r1.ebuild
new file mode 100644 (file)
index 0000000..a315545
--- /dev/null
@@ -0,0 +1,141 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=5
+
+JAVA_PKG_IUSE="source test"
+
+inherit eutils java-pkg-2 java-ant-2 prefix user
+
+MY_P="apache-${P}-src"
+
+DESCRIPTION="Tomcat Servlet-2.5/JSP-2.1 Container"
+HOMEPAGE="http://tomcat.apache.org/"
+SRC_URI="mirror://apache/${PN}/tomcat-6/v${PV}/src/${MY_P}.tar.gz"
+
+LICENSE="Apache-2.0"
+SLOT="6"
+KEYWORDS="~amd64 ~ppc ~ppc64 ~x86 ~x86-fbsd"
+IUSE="extra-webapps"
+
+ECJ_SLOT="3.7"
+SAPI_SLOT="2.5"
+
+COMMON_DEP="dev-java/eclipse-ecj:${ECJ_SLOT}
+       dev-java/oracle-javamail:0
+       dev-java/tomcat-servlet-api:${SAPI_SLOT}"
+RDEPEND="${COMMON_DEP}
+       >=virtual/jre-1.6
+       !<dev-java/tomcat-native-1.1.20"
+DEPEND="${COMMON_DEP}
+       >=virtual/jdk-1.6
+       test? ( dev-java/ant-junit:0 )"
+
+S=${WORKDIR}/${MY_P}
+
+pkg_setup() {
+       java-pkg-2_pkg_setup
+       enewgroup tomcat 265
+       enewuser tomcat 265 -1 /dev/null tomcat
+}
+
+java_prepare() {
+       find -name '*.jar' -type f -delete -print || die
+
+       # Remove bundled javamail, servlet-api
+       rm -rv java/javax/{mail,servlet} || die
+
+       epatch "${FILESDIR}/${P}-build.xml.patch"
+
+       # For use of catalina.sh in netbeans
+       sed -i -e "/^# ----- Execute The Requested Command/ a\
+               CLASSPATH=\`java-config --classpath ${PN}-${SLOT}\`" \
+               bin/catalina.sh || die
+}
+
+JAVA_ANT_REWRITE_CLASSPATH="true"
+
+EANT_BUILD_TARGET="deploy"
+EANT_TEST_TARGET="all"
+EANT_GENTOO_CLASSPATH="eclipse-ecj-${ECJ_SLOT},oracle-javamail,tomcat-servlet-api-${SAPI_SLOT}"
+EANT_GENTOO_CLASSPATH_EXTRA="${S}/output/classes"
+EANT_NEEDS_TOOLS="true"
+EANT_EXTRA_ARGS="-Dversion=${PV}-gentoo -Dversion.number=${PV} -Dcompile.debug=false"
+
+# revisions of the scripts
+IM_REV="-r1"
+INIT_REV="-r1"
+
+src_compile() {
+       EANT_GENTOO_CLASSPATH_EXTRA+=":$(java-pkg_getjar --build-only ant-core ant.jar)"
+       java-pkg-2_src_compile
+}
+
+src_test() {
+       EANT_BUILD_XML="test/build.xml" java-pkg-2_src_test
+}
+
+src_install() {
+       local dest="/usr/share/${PN}-${SLOT}"
+
+       java-pkg_jarinto "${dest}"/bin
+       java-pkg_dojar output/build/bin/*.jar
+       exeinto "${dest}"/bin
+       doexe output/build/bin/*.sh
+
+       java-pkg_jarinto "${dest}"/lib
+       java-pkg_dojar output/build/lib/*.jar
+
+       dodoc RELEASE-NOTES RUNNING.txt
+       use source && java-pkg_dosrc java/*
+
+       ### Webapps ###
+
+       insinto "${dest}"/webapps
+       doins -r output/build/webapps/{host-manager,manager,ROOT}
+       use extra-webapps && doins -r output/build/webapps/{docs,examples}
+
+       ### Config ###
+
+       # create "logs" directory in $CATALINA_BASE
+       # and set correct perms, see #458890
+       dodir "${dest}"/logs
+       fperms 0750 "${dest}"/logs
+
+       # replace the default pw with a random one, see #92281
+       local randpw=$(echo ${RANDOM}|md5sum|cut -c 1-15)
+       sed -i -e "s|SHUTDOWN|${randpw}|" output/build/conf/server.xml || die
+
+       # prepend gentoo.classpath to common.loader, see #453212
+       sed -i -e 's/^common\.loader=/\0${gentoo.classpath},/' output/build/conf/catalina.properties || die
+
+       insinto "${dest}"
+       doins -r output/build/conf
+
+       ### rc ###
+
+       cp "${FILESDIR}"/tomcat{.conf,${INIT_REV}.init,-instance-manager${IM_REV}.bash} "${T}" || die
+       eprefixify "${T}"/tomcat{.conf,${INIT_REV}.init,-instance-manager${IM_REV}.bash}
+       sed -i -e "s|@SLOT@|${SLOT}|g" "${T}"/tomcat{.conf,${INIT_REV}.init,-instance-manager${IM_REV}.bash} || die
+
+       insinto "${dest}"/gentoo
+       doins "${T}"/tomcat.conf
+       exeinto "${dest}"/gentoo
+       newexe "${T}"/tomcat${INIT_REV}.init tomcat.init
+       newexe "${T}"/tomcat-instance-manager${IM_REV}.bash tomcat-instance-manager.bash
+}
+
+pkg_postinst() {
+       elog "New ebuilds of Tomcat support running multiple instances. If you used prior version"
+       elog "of Tomcat (<6.0.36), you have to migrate your existing instance to work with new Tomcat."
+       elog "You can find more information at https://wiki.gentoo.org/wiki/Apache_Tomcat"
+
+       elog "To manage Tomcat instances, run:"
+       elog "  ${EPREFIX}/usr/share/${PN}-${SLOT}/gentoo/tomcat-instance-manager.bash --help"
+
+       ewarn "tomcat-dbcp.jar is not built at this time. Please fetch jar"
+       ewarn "from upstream binary if you need it. Gentoo Bug # 144276"
+
+#      einfo "Please read http://www.gentoo.org/proj/en/java/tomcat6-guide.xml for more information."
+}
diff --git a/www-servers/tomcat/tomcat-7.0.63.ebuild b/www-servers/tomcat/tomcat-7.0.63.ebuild
new file mode 100644 (file)
index 0000000..e4f542a
--- /dev/null
@@ -0,0 +1,146 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=5
+
+JAVA_PKG_IUSE="doc source test"
+
+inherit eutils java-pkg-2 java-ant-2 prefix user
+
+MY_P="apache-${P}-src"
+
+DESCRIPTION="Tomcat Servlet-3.0/JSP-2.2 Container"
+HOMEPAGE="http://tomcat.apache.org/"
+SRC_URI="mirror://apache/${PN}/tomcat-7/v${PV}/src/${MY_P}.tar.gz"
+
+LICENSE="Apache-2.0"
+SLOT="7"
+KEYWORDS="~amd64 ~ppc ~ppc64 ~x86 ~x86-freebsd ~amd64-linux ~x86-linux ~x86-solaris"
+IUSE="extra-webapps websockets"
+
+RESTRICT="test" # can we run them on a production system?
+
+ECJ_SLOT="4.4"
+SAPI_SLOT="3.0"
+
+COMMON_DEP="dev-java/eclipse-ecj:${ECJ_SLOT}
+       dev-java/oracle-javamail:0
+       dev-java/tomcat-servlet-api:${SAPI_SLOT}"
+RDEPEND="${COMMON_DEP}
+       websockets? ( >=virtual/jre-1.7 )
+       !websockets? ( >=virtual/jre-1.6 )
+       !<dev-java/tomcat-native-1.1.24"
+DEPEND="${COMMON_DEP}
+       websockets? ( >=virtual/jdk-1.7 )
+       !websockets? ( >=virtual/jdk-1.6 )
+       test? ( dev-java/ant-junit:0 )"
+
+S=${WORKDIR}/${MY_P}
+
+pkg_setup() {
+       java-pkg-2_pkg_setup
+       enewgroup tomcat 265
+       enewuser tomcat 265 -1 /dev/null tomcat
+}
+
+java_prepare() {
+       find -name '*.jar' -type f -delete -print || die
+
+       # Remove bundled javamail, servlet-api
+       rm -rv java/javax/{el,mail,servlet} || die
+
+       epatch "${FILESDIR}/${P}-build.xml.patch"
+
+       # For use of catalina.sh in netbeans
+       sed -i -e "/^# ----- Execute The Requested Command/ a\
+               CLASSPATH=\`java-config --classpath ${PN}-${SLOT}\`" \
+               bin/catalina.sh || die
+}
+
+JAVA_ANT_REWRITE_CLASSPATH="true"
+
+EANT_BUILD_TARGET="deploy"
+EANT_GENTOO_CLASSPATH="eclipse-ecj-${ECJ_SLOT},oracle-javamail,tomcat-servlet-api-${SAPI_SLOT}"
+EANT_GENTOO_CLASSPATH_EXTRA="${S}/output/classes"
+EANT_NEEDS_TOOLS="true"
+EANT_EXTRA_ARGS="-Dversion=${PV}-gentoo -Dversion.number=${PV} -Dcompile.debug=false"
+
+# revisions of the scripts
+IM_REV="-r1"
+INIT_REV="-r1"
+
+src_compile() {
+       use websockets && EANT_EXTRA_ARGS+=" -Djava.7.home=${JAVA_HOME}"
+       EANT_GENTOO_CLASSPATH_EXTRA+=":$(java-pkg_getjar --build-only ant-core ant.jar)"
+       java-pkg-2_src_compile
+}
+
+src_test() {
+       java-pkg-2_src_test
+}
+
+src_install() {
+       local dest="/usr/share/${PN}-${SLOT}"
+
+       java-pkg_jarinto "${dest}"/bin
+       java-pkg_dojar output/build/bin/*.jar
+       exeinto "${dest}"/bin
+       doexe output/build/bin/*.sh
+
+       java-pkg_jarinto "${dest}"/lib
+       java-pkg_dojar output/build/lib/*.jar
+
+       dodoc RELEASE-NOTES RUNNING.txt
+       use doc && java-pkg_dojavadoc output/dist/webapps/docs/api
+       use source && java-pkg_dosrc java/*
+
+       ### Webapps ###
+
+       insinto "${dest}"/webapps
+       doins -r output/build/webapps/{host-manager,manager,ROOT}
+       use extra-webapps && doins -r output/build/webapps/{docs,examples}
+
+       ### Config ###
+
+       # create "logs" directory in $CATALINA_BASE
+       # and set correct perms, see #458890
+       dodir "${dest}"/logs
+       fperms 0750 "${dest}"/logs
+
+       # replace the default pw with a random one, see #92281
+       local randpw=$(echo ${RANDOM}|md5sum|cut -c 1-15)
+       sed -i -e "s|SHUTDOWN|${randpw}|" output/build/conf/server.xml || die
+
+       # prepend gentoo.classpath to common.loader, see #453212
+       sed -i -e 's/^common\.loader=/\0${gentoo.classpath},/' output/build/conf/catalina.properties || die
+
+       insinto "${dest}"
+       doins -r output/build/conf
+
+       ### rc ###
+
+       cp "${FILESDIR}"/tomcat{.conf,${INIT_REV}.init,-instance-manager${IM_REV}.bash} "${T}" || die
+       eprefixify "${T}"/tomcat{.conf,${INIT_REV}.init,-instance-manager${IM_REV}.bash}
+       sed -i -e "s|@SLOT@|${SLOT}|g" "${T}"/tomcat{.conf,${INIT_REV}.init,-instance-manager${IM_REV}.bash} || die
+
+       insinto "${dest}"/gentoo
+       doins "${T}"/tomcat.conf
+       exeinto "${dest}"/gentoo
+       newexe "${T}"/tomcat${INIT_REV}.init tomcat.init
+       newexe "${T}"/tomcat-instance-manager${IM_REV}.bash tomcat-instance-manager.bash
+}
+
+pkg_postinst() {
+       elog "New ebuilds of Tomcat support running multiple instances. If you used prior version"
+       elog "of Tomcat (<7.0.32), you have to migrate your existing instance to work with new Tomcat."
+       elog "You can find more information at https://wiki.gentoo.org/wiki/Apache_Tomcat"
+
+       elog "To manage Tomcat instances, run:"
+       elog "  ${EPREFIX}/usr/share/${PN}-${SLOT}/gentoo/tomcat-instance-manager.bash --help"
+
+       ewarn "tomcat-dbcp.jar is not built at this time. Please fetch jar"
+       ewarn "from upstream binary if you need it. Gentoo Bug # 144276"
+
+#      einfo "Please read http://www.gentoo.org/proj/en/java/tomcat6-guide.xml for more information."
+}
diff --git a/www-servers/tomcat/tomcat-8.0.24.ebuild b/www-servers/tomcat/tomcat-8.0.24.ebuild
new file mode 100644 (file)
index 0000000..4d74ee6
--- /dev/null
@@ -0,0 +1,147 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=5
+
+JAVA_PKG_IUSE="doc source test"
+
+inherit eutils java-pkg-2 java-ant-2 prefix user
+
+MY_P="apache-${P}-src"
+
+DESCRIPTION="Tomcat Servlet-3.1/JSP-2.3 Container"
+HOMEPAGE="http://tomcat.apache.org/"
+SRC_URI="mirror://apache/${PN}/tomcat-8/v${PV}/src/${MY_P}.tar.gz"
+
+LICENSE="Apache-2.0"
+SLOT="8"
+KEYWORDS="~amd64 ~x86 ~x86-fbsd ~x86-freebsd ~amd64-linux ~x86-linux ~x86-solaris"
+IUSE="extra-webapps"
+
+RESTRICT="test" # can we run them on a production system?
+
+ECJ_SLOT="4.4"
+SAPI_SLOT="3.1"
+
+COMMON_DEP="dev-java/eclipse-ecj:${ECJ_SLOT}
+       dev-java/oracle-javamail:0
+       dev-java/tomcat-servlet-api:${SAPI_SLOT}"
+RDEPEND="${COMMON_DEP}
+       !<dev-java/tomcat-native-1.1.24
+       >=virtual/jre-1.7"
+DEPEND="${COMMON_DEP}
+       >=virtual/jdk-1.7
+       test? (
+               >=dev-java/ant-junit-1.9:0
+               dev-java/easymock:3.2
+       )"
+
+S=${WORKDIR}/${MY_P}
+
+pkg_setup() {
+       java-pkg-2_pkg_setup
+       enewgroup tomcat 265
+       enewuser tomcat 265 -1 /dev/null tomcat
+}
+
+java_prepare() {
+       find -name '*.jar' -type f -delete -print || die
+
+       # Remove bundled javamail, servlet-api
+       rm -rv java/javax/{el,mail,servlet} || die
+
+       epatch "${FILESDIR}/${P}-build.xml.patch"
+
+       # For use of catalina.sh in netbeans
+       sed -i -e "/^# ----- Execute The Requested Command/ a\
+               CLASSPATH=\`java-config --classpath ${PN}-${SLOT}\`" \
+               bin/catalina.sh || die
+}
+
+JAVA_ANT_REWRITE_CLASSPATH="true"
+
+EANT_BUILD_TARGET="deploy"
+EANT_GENTOO_CLASSPATH="eclipse-ecj-${ECJ_SLOT},oracle-javamail,tomcat-servlet-api-${SAPI_SLOT}"
+EANT_TEST_GENTOO_CLASSPATH="easymock-3.2"
+EANT_GENTOO_CLASSPATH_EXTRA="${S}/output/classes"
+EANT_NEEDS_TOOLS="true"
+EANT_EXTRA_ARGS="-Dversion=${PV}-gentoo -Dversion.number=${PV} -Dcompile.debug=false"
+
+# revisions of the scripts
+IM_REV="-r1"
+INIT_REV="-r1"
+
+src_compile() {
+       EANT_GENTOO_CLASSPATH_EXTRA+=":$(java-pkg_getjar --build-only ant-core ant.jar)"
+       java-pkg-2_src_compile
+}
+
+src_test() {
+       java-pkg-2_src_test
+}
+
+src_install() {
+       local dest="/usr/share/${PN}-${SLOT}"
+
+       java-pkg_jarinto "${dest}"/bin
+       java-pkg_dojar output/build/bin/*.jar
+       exeinto "${dest}"/bin
+       doexe output/build/bin/*.sh
+
+       java-pkg_jarinto "${dest}"/lib
+       java-pkg_dojar output/build/lib/*.jar
+
+       dodoc RELEASE-NOTES RUNNING.txt
+       use doc && java-pkg_dojavadoc output/dist/webapps/docs/api
+       use source && java-pkg_dosrc java/*
+
+       ### Webapps ###
+
+       insinto "${dest}"/webapps
+       doins -r output/build/webapps/{host-manager,manager,ROOT}
+       use extra-webapps && doins -r output/build/webapps/{docs,examples}
+
+       ### Config ###
+
+       # create "logs" directory in $CATALINA_BASE
+       # and set correct perms, see #458890
+       dodir "${dest}"/logs
+       fperms 0750 "${dest}"/logs
+
+       # replace the default pw with a random one, see #92281
+       local randpw=$(echo ${RANDOM}|md5sum|cut -c 1-15)
+       sed -i -e "s|SHUTDOWN|${randpw}|" output/build/conf/server.xml || die
+
+       # prepend gentoo.classpath to common.loader, see #453212
+       sed -i -e 's/^common\.loader=/\0${gentoo.classpath},/' output/build/conf/catalina.properties || die
+
+       insinto "${dest}"
+       doins -r output/build/conf
+
+       ### rc ###
+
+       cp "${FILESDIR}"/tomcat{.conf,${INIT_REV}.init,-instance-manager${IM_REV}.bash} "${T}" || die
+       eprefixify "${T}"/tomcat{.conf,${INIT_REV}.init,-instance-manager${IM_REV}.bash}
+       sed -i -e "s|@SLOT@|${SLOT}|g" "${T}"/tomcat{.conf,${INIT_REV}.init,-instance-manager${IM_REV}.bash} || die
+
+       insinto "${dest}"/gentoo
+       doins "${T}"/tomcat.conf
+       exeinto "${dest}"/gentoo
+       newexe "${T}"/tomcat${INIT_REV}.init tomcat.init
+       newexe "${T}"/tomcat-instance-manager${IM_REV}.bash tomcat-instance-manager.bash
+}
+
+pkg_postinst() {
+       elog "New ebuilds of Tomcat support running multiple instances. If you used prior version"
+       elog "of Tomcat (<7.0.32), you have to migrate your existing instance to work with new Tomcat."
+       elog "You can find more information at https://wiki.gentoo.org/wiki/Apache_Tomcat"
+
+       elog "To manage Tomcat instances, run:"
+       elog "  ${EPREFIX}/usr/share/${PN}-${SLOT}/gentoo/tomcat-instance-manager.bash --help"
+
+       ewarn "tomcat-dbcp.jar is not built at this time. Please fetch jar"
+       ewarn "from upstream binary if you need it. Gentoo Bug # 144276"
+
+#      einfo "Please read http://www.gentoo.org/proj/en/java/tomcat6-guide.xml for more information."
+}